<!DOCTYPE html>
<html>

<head>
  <title> Tạo đơn hàng - dành cho Admin </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron py-4">
    <h1 class="text-center mb-5"> Create Pizza Order - For Admin </h1>
    <div class="form-group row">
      <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
      <div class="col-sm-4">
        <select class="form-control" id="select-size">
          <option value="NOT_SELECT_COMBO"> Chọn cỡ Combo (Combo size)</option>
          <option value="S"> Nhỏ</option>
          <option value="M"> Vừa</option>
          <option value="L"> Lớn</option>
        </select>
      </div>
      <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
      <div class="col-sm-4">
        <select class="form-control" id="select-drink">
          <option value="NOT_SELECT_DRINK">Chọn đồ uống</option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Mã voucher</label>
      <div class="col-sm-4">
        <input type="text" id="inp-voucher" class="form-control" placeholder="Voucher ID (mã voucher)">
      </div>
      <label class="col-sm-2 col-form-label">Loại pizza</label>
      <div class="col-sm-4">
        <select class="form-control" id="select-pizza">
          <option value="NOT_SELECT_PIZZA"> Chọn loại pizza </option>
          <option value="Seafood"> Hải sản</option>
          <option value="Hawaii"> Ha wai </option>
          <option value="Bacon"> Thịt hun khói </option>
        </select>
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
      <div class="col-sm-4">
        <input type="text" id="inp-fullname" class="form-control" placeholder="Họ và tên">
      </div>
      <label for="" class="col-sm-2 col-form-label">Email</label>
      <div class="col-sm-4">
        <input type="email" id="inp-email" class="form-control" placeholder="Email">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Số điện thoại</label>
      <div class="col-sm-4">
        <input type="text" id="inp-phonenumber" class="form-control" placeholder="Số điện thoại">
      </div>
      <label class="col-sm-2 col-form-label">Địa chỉ</label>
      <div class="col-sm-4">
        <input type="text" id="inp-address" class="form-control" placeholder="Địa chỉ">
      </div>
    </div>
    <div class="form-group row">
      <label class="col-sm-2 col-form-label">Lời nhắn</label>
      <div class="col-sm-10">
        <textarea class="form-control" id="inp-message" placeholder="Lời nhắn"></textarea>
      </div>
    </div>
    <div class="form-group text-right">
      <button class="btn btn-primary" onclick="onBtnCreateOrderClick()">Create Order</button>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; //tạo đơn hàng thành công
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders"; 
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }
    function onBtnCreateOrderClick(){
      "use strict";
      console.log("Nút create order được ấn");
      //khai bao doi tuong chua du lieu order
      var vOrderObject = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVourcher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: ""
      }
      //b1 đọc dữ liệu
      readDataInput(vOrderObject);
      //ghi ra console để xem đọc được chưa
      console.log(vOrderObject);
      //b2 validate dữ liệu
      var vIsCheck = validateDataInput(vOrderObject);
      //ghi ra console để xem kết quả kiểm tra
      console.log(vIsCheck);
      if(vIsCheck){
        //b3 gọi api send request
        var vXmlHttp = new XMLHttpRequest();
        callApiGetDataOrder(vXmlHttp,vOrderObject);
        //b4 xử lý hiển thị sau khi request thành công
        vXmlHttp.onreadystatechange = function(){
          if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS){
            handleCreateData(vXmlHttp);
          }
        }
      }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm đọc dữ liệu input từ web
    function readDataInput(paramOrderObject){
      "use strict"
      //truy xuất id của từng input từ web
      var vSelectComboSizeElement = document.getElementById("select-size");
      var vSelectDrinkElement = document.getElementById("select-drink");
      var vVoucherElement = document.getElementById("inp-voucher");
      var vSelectPizzaElement = document.getElementById("select-pizza");
      var vFullNameElement = document.getElementById("inp-fullname");
      var vEmailElement = document.getElementById("inp-email");
      var vMobileElement = document.getElementById("inp-phonenumber");
      var vAddressElement = document.getElementById("inp-address");
      var vMessageElement = document.getElementById("inp-message");

      paramOrderObject.kichCo = vSelectComboSizeElement.value;
      paramOrderObject.idLoaiNuocUong = vSelectDrinkElement.value;
      paramOrderObject.soLuongNuoc = vSelectDrinkElement.value;
      paramOrderObject.idVourcher = vVoucherElement.value.trim();
      paramOrderObject.loaiPizza  = vSelectPizzaElement.value;
      paramOrderObject.hoTen = vFullNameElement.value.trim();
      paramOrderObject.email = vEmailElement.value.trim();
      paramOrderObject.soDienThoai = vMobileElement.value.trim();
      paramOrderObject.diaChi = vAddressElement.value.trim();
      paramOrderObject.loiNhan = vMessageElement.value.trim();

      //nếu người dùng chọn size S,M,L
      if(paramOrderObject.kichCo == "S"){
        paramOrderObject.duongKinh = 20;
        paramOrderObject.suon = 2;
        paramOrderObject.salad = 200;
        paramOrderObject.soLuongNuoc = 2;
        paramOrderObject.thanhTien = 150000;
      }
      else if(paramOrderObject.kichCo == "M"){
        paramOrderObject.duongKinh = 24;
        paramOrderObject.suon = 4;
        paramOrderObject.salad = 300;
        paramOrderObject.soLuongNuoc = 4;
        paramOrderObject.thanhTien = 200000;
      }
      else if(paramOrderObject.kichCo == "L"){
        paramOrderObject.duongKinh = 30;
        paramOrderObject.suon = 8;
        paramOrderObject.salad = 500;
        paramOrderObject.soLuongNuoc = 4;
        paramOrderObject.thanhTien = 250000;
      }
    }
    function validateDataInput(paramOrderObject){
      "use strict";
      //kiểm tra xem đã chọn cỡ combo chưa
      if(paramOrderObject.kichCo == "NOT_SELECT_COMBO"){
        alert("Bạn cần chọn combo");
        return false;
      }
      //kiểm tra xem đã chọn nước chưa
      if(paramOrderObject.idLoaiNuocUong == "NOT_SELECT_DRINK"){
        alert("Bạn cần chọn đồ uống");
        return false;
      }
      //kiểm tra xem đã chọn loại pizza chưa
      if(paramOrderObject.loaiPizza == "NOT_SELECT_PIZZA"){
        alert("Bạn cần chọn loại pizza");
        return false;
      }
      //kiểm tra xem đã nhập tên chưa
      if(paramOrderObject.hoTen == ""){
        alert("Bạn cần nhập tên");
        return false;
      }
      //kiểm tra xem đã nhập email chưa
      if(paramOrderObject.email == ""){
        alert("Bạn cần nhập email");
        return false;
      }
      //gọi hàm kiểm tra email
      var vKiemTraEmail = validateEmail(paramOrderObject.email);
      if(!vKiemTraEmail){
        alert("Bạn cần nhập đúng định dạng");
        return false;
      }
      //kiểm tra xem nhập số điện thoại chưa
      if(paramOrderObject.soDienThoai == ""){
        alert("Bạn cần nhập số điện thoại");
        return false;
      }
      //gọi hàm kiểm tra phone number
      var vKiemTraSoDienThoai = validatePhoneNumber(paramOrderObject.soDienThoai);
      if(!vKiemTraSoDienThoai){
        alert("Bạn cần nhập đúng định dạng");
        return false;
      }
      //kiểm tra xem đã nhập địa chỉ chưa
      if(paramOrderObject.diaChi == ""){
        alert("Cần nhập địa chỉ");
        return false;
      }
      return true;
    }
    //hàm kiểm tra email
    function validateEmail(paramEmail){
      var vFormatReg = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/;
      var vCheck = vFormatReg.test(paramEmail);
      return vCheck;
    }
    //hàm kiểm tra số điện thoại
    function validatePhoneNumber(paramPhoneNumber){
      var vFormatReg = /^\d{10}$/;
      if(paramPhoneNumber.match(vFormatReg)){
        return true;
      } else{
        return false;
      }
      
    }
    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
          console.log(vXhttp.responseText); // ghi response text ra console.log
          handleLoadDataToSelectDrink(vXhttp);
        }
      };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      // load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var bDrinkOptionElement = document.createElement("option");
        bDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        bDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(bDrinkOptionElement);
      }
    }

    //call api send request
    function callApiGetDataOrder(paramXmlHttp,paramOrderObject){
      "use strict";
      paramXmlHttp.open("POST",gBASE_URL,true);
      paramXmlHttp.setRequestHeader("Content-Type","application/json;charset=UTF-8");
      paramXmlHttp.send(JSON.stringify(paramOrderObject));
      console.log(paramOrderObject);
    }
    //ham xu ly hien thi sau khi response thanh công
    function handleCreateData(paramXmlHttp){
      "use strict";
      console.log(paramXmlHttp.responseText);
      alert("Tạo đơn hàng thành công");
      const vINDEX_LIST_VIEW_FORM_URL = "index.html";
      var vUrlSiteToOpen = vINDEX_LIST_VIEW_FORM_URL;
      window.location.href = vUrlSiteToOpen;
    }

  </script>


</body>

</html>